unit child;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}
interface

uses
  {$ifdef fpc}
    LResources,
    LCLIntf,
  {$endif}
  {$ifdef Unix}
    LIBC,
  {$else}
    Windows,
    WinSock,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  Buttons,
  IniFiles,
  Zusatz,
  WolfUtil,
  Hexagon,
  Thread;

const
  Rand            = 10;

type
  TChildForm      = class(TForm)
    Hexagon1      : tHexagon;
    Hexagon2      : tHexagon;
    Hexagon3      : tHexagon;
    Hexagon4      : tHexagon;
    Hexagon5      : tHexagon;
    Hexagon6      : tHexagon;
    Hexagon7      : tHexagon;
    Hexagon8      : tHexagon;
    Hexagon9      : tHexagon;
    Hexagon10     : tHexagon;
    Hexagon11     : tHexagon;
    Hexagon12     : tHexagon;
    Hexagon13     : tHexagon;
    Hexagon14     : tHexagon;
    Hexagon15     : tHexagon;
    Hexagon16     : tHexagon;
    Hexagon17     : tHexagon;
    Hexagon18     : tHexagon;
    Hexagon19     : tHexagon;
    Hexagon20     : tHexagon;
    Hexagon21     : tHexagon;
    Hexagon22     : tHexagon;
    Hexagon23     : tHexagon;
    Hexagon24     : tHexagon;
    Hexagon25     : tHexagon;
    Hexagon26     : tHexagon;
    Hexagon27     : tHexagon;
    Hexagon113    : tHexagon;
    Hexagon124    : tHexagon;
    Hexagon135    : tHexagon;
    Hexagon212    : tHexagon;
    Hexagon223    : tHexagon;
    Hexagon234    : tHexagon;
    Hexagon245    : tHexagon;
    Hexagon311    : tHexagon;
    Hexagon322    : tHexagon;
    Hexagon333    : tHexagon;
    Hexagon344    : tHexagon;
    Hexagon355    : tHexagon;
    Hexagon421    : tHexagon;
    Hexagon432    : tHexagon;
    Hexagon443    : tHexagon;
    Hexagon454    : tHexagon;
    Hexagon531    : tHexagon;
    Hexagon542    : tHexagon;
    Hexagon553    : tHexagon;
    Hoch1         : tPkteLabel;
    Hoch2         : tPkteLabel;
    Hoch3         : tPkteLabel;
    Hoch4         : tPkteLabel;
    Hoch5         : tPkteLabel;
    Ab1           : tPkteLabel;
    Ab2           : tPkteLabel;
    Ab3           : tPkteLabel;
    Ab4           : tPkteLabel;
    Ab5           : tPkteLabel;
    Auf1          : tPkteLabel;
    Auf2          : tPkteLabel;
    Auf3          : tPkteLabel;
    Auf4          : tPkteLabel;
    Auf5          : tPkteLabel;
    BtnOk         : TButton;
    Bewertung     : TRadioGroup;
    BitBtn        : TBitBtn;
    procedure       BtnOkClick(Sender: TObject);
    procedure       BewertungClick(Sender: TObject);
    procedure       FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure       Drop(Sender: TObject);
    procedure       MouseDownHex(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    procedure       MouseUpSonst(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    procedure       MouseUpStein(Sender: TObject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    procedure       FormCreate(Sender: TObject);
    procedure       FormResize(Sender: TObject);
    procedure       MouseMoveStein(Sender: TObject; Shift: TShiftState;
                                   X, Y: Integer);
    procedure       FormPaint(Sender: TObject);
    procedure       BitBtnClick(Sender: TObject);
    procedure       FormDestroy(Sender: TObject);
  private
    ToDrag,
    ToConfirm     : tHexagon;
    BeforeDrag,
    DragOrigin    : tPoint;
    Start         : Boolean;
    procedure       Lay(Stein, Ziel: tHexagon);
    procedure       SteinOk;
    procedure       NewSize;
    procedure       SendeAllen(Telegramm : tTelegramm);
  public
    Ips           : tLongIntList;
    RemoteHandle  : tHandle;
    Hexagon,
    Punkte        : Word;
    Running,
    ToPlace       : Boolean;
    procedure       PCSpiel;
    procedure       Init(Steine : tSteine);
    procedure       NextStein;
    procedure       Calculate;
    procedure       SteinGesetzt(Nr         : ShortInt;
                                 Ziel       : Word;
                                 Endgueltig : Boolean);
    procedure       SendeSpiel(Ziel : LongInt);
    procedure       NewColors;
    procedure       Schliessen;
  end;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

uses
  main,
  Chat;

procedure TChildForm.SendeAllen(Telegramm : tTelegramm);
  var     i : Integer;
  begin
    if IPs <> Nil then
      if MainForm.Hosts <> Nil then
        for i := MainForm.Hosts.Count - 1 downto 0 do
          begin
            case Telegramm.Kennung of
              TelegrammMitspieler :
                begin
                  Telegramm.MitspielStdIp :=
                    MainForm.GetStdIp(MainForm.Hosts[i], Ips);
                  Telegramm.MitspielIp := Telegramm.MitspielStdIp;
                end;
              TelegrammChat :
                begin
                  Telegramm.ChatStdIp :=
                    MainForm.GetStdIp(MainForm.Hosts[i], Ips);
                  Telegramm.ChatIp := Telegramm.ChatStdIp;
                end;
              TelegrammSteinGesetzt :
                Telegramm.GesetztIp :=
                  MainForm.GetStdIp(MainForm.Hosts[i], Ips);
              TelegrammEnde :
                Telegramm.EndeIp := MainForm.GetStdIp(MainForm.Hosts[i], Ips);
              TelegrammSteinTest :
                Telegramm.GesetztIp :=
                  MainForm.GetStdIp(MainForm.Hosts[i], Ips);
            end;
            MainForm.SendTelegramm(Telegramm, MainForm.Hosts[i]);
          end;
  end;

procedure TChildForm.NewColors;
  var i : Integer;
  begin
    Color := GlobBackground;
    for i := 0 to ControlCount - 1 do
      if Controls[i] is tHexagon then
        (Controls[i] as tHexagon).NewColors(
          GlobLineColors, GlobBackground, GlobLight, GlobShadow)
      else
        if Controls[i] is tPkteLabel then
          (Controls[i] as tPkteLabel).NewColors;
  end;

procedure TChildForm.Init(Steine : tSteine);
  var     s : String;
          i : Integer;
  begin
    Hexagon := 1;
    ToPlace := True;
    for i := 1 to GesamtSteine do
      begin
        Str(i, s);
        (FindComponent(HexName + s) as tHexagon).Init(Steine[i], hxHidden);
      end;
    Hexagon1.Style := hxHighlight;
    Hexagon113.Init(1, hxEmpty);
    Hexagon124.Init(1, hxEmpty);
    Hexagon135.Init(1, hxEmpty);
    Hexagon212.Init(1, hxEmpty);
    Hexagon223.Init(1, hxEmpty);
    Hexagon234.Init(1, hxEmpty);
    Hexagon245.Init(1, hxEmpty);
    Hexagon311.Init(1, hxEmpty);
    Hexagon322.Init(1, hxEmpty);
    Hexagon333.Init(1, hxEmpty);
    Hexagon344.Init(1, hxEmpty);
    Hexagon355.Init(1, hxEmpty);
    Hexagon421.Init(1, hxEmpty);
    Hexagon432.Init(1, hxEmpty);
    Hexagon443.Init(1, hxEmpty);
    Hexagon454.Init(1, hxEmpty);
    Hexagon531.Init(1, hxEmpty);
    Hexagon542.Init(1, hxEmpty);
    Hexagon553.Init(1, hxEmpty);
  end;

procedure TChildForm.BtnOkClick(Sender: TObject);
  begin
    SteinOk;
  end;

procedure TChildForm.SteinOk;
  var     s         : String;
          Telegramm : tTelegramm;
          Hex       : tHexagon;
          i, e      : Integer;
  begin
    if Hexagon <= ZuSetzen then
      begin
        ToPlace       := False;
        BtnOk.Enabled := False;
        str(Hexagon, s);
        Hex := (Findcomponent(HexName + s) as tHexagon);
        Hex.Style := hxVisible;
        if Ips <> Nil then
          if Ips.Count > 0 then
            if MainForm.MyIps <> Nil then
              if MainForm.MyIps.IndexOf(Ips[0]) >= 0 then
                begin
                  s := Hex.GetOccupation.Name;
                  s := Copy(s, length(HexName) + 1, length(s));
                  val(s, i, e);
                  Telegramm.Kennung       := TelegrammSteinGesetzt;
                  Telegramm.GesetztHandle := RemoteHandle;
                  Telegramm.GesetztNr     := Hexagon;
                  Telegramm.GesetztZiel   := i;
                  Telegramm.GesetztIp     := Ips[0];
                  SendeAllen(Telegramm);
                end;
        MainForm.NextWindow;
      end
    else
      Schliessen;
  end;

procedure TChildForm.PCSpiel;
  var     i, Max,
          Offset,
          BewMode,
          PCPunkte : Integer;
          s        : String;
          Stein    : tHexagon;
  begin
    BewMode := Bewertung.ItemIndex;
    Bewertung.ItemIndex := 1;
    str(Hexagon, s);
    Max      := -1;
    PCPunkte := -1;
    Stein    := FindComponent(HexName + s) as tHexagon;
    Offset   := Random(ComponentCount);
    for i := 0 to ComponentCount - 1 do
      begin
        Offset := (Offset + 1) mod ComponentCount;
        if Components[Offset] is tHexagon then
          if (Components[Offset] as tHexagon).Style = hxEmpty then
            if (Components[Offset] as tHexagon).GetOccupation = Nil Then
              begin
                (Components[Offset] as tHexagon).Occupy(Stein);
                Stein.Occupy(Components[Offset] as tHexagon);
                Calculate;
                if Punkte > PCPunkte Then
                  begin
                    Max      := Offset;
                    PCPunkte := Punkte;
                  end;
                (Components[Offset] as tHexagon).FreeOccupation;
                Stein.FreeOccupation;
              end;
      end;
    Lay(Stein, Components[Max] as tHexagon);
    Bewertung.ItemIndex := BewMode;
  end;

procedure TChildForm.NextStein;
  var     s     : String;
          Stein : tHexagon;
  begin
    if (Hexagon < ZuSetzen) then
      begin
        inc(Hexagon);
        str(Hexagon, s);
        Stein := FindComponent(HexName + s) as tHexagon;
        Stein.Style := hxHighlight;
        if Caption = 'PC' Then
          PCSpiel;
        ToPlace := True;
      end
    else
      begin
        while Hexagon < GesamtSteine do
          begin
            inc(Hexagon);
            str(Hexagon, s);
            Stein := FindComponent(HexName + s) as tHexagon;
            Stein.Style := hxVisible;
          end;
        BtnOk.Enabled := True;
      end;
  end;

procedure tChildForm.Calculate;
  var     BewMode : tBewertung;
          s       : String;
  begin
    if Bewertung.Itemindex = 0 then
      BewMode := bewPunkte
    else
      if Hexagon <= 4 Then
        BewMode := bewAnfang
      else
        BewMode := bewEnde;
    Punkte := 0;
    Inc(Punkte, Hoch1.Calculate(Hexagon113,
                                Hexagon124,
                                Hexagon135,
                                nil,
                                nil,
                                rHoch, BewMode));
    Inc(Punkte, Hoch2.Calculate(Hexagon212,
                                Hexagon223,
                                Hexagon234,
                                Hexagon245,
                                nil,
                                rHoch, BewMode));
    Inc(Punkte, Hoch3.Calculate(Hexagon311,
                                Hexagon322,
                                Hexagon333,
                                Hexagon344,
                                Hexagon355,
                                rHoch, BewMode));
    Inc(Punkte, Hoch4.Calculate(Hexagon421,
                                Hexagon432,
                                Hexagon443,
                                Hexagon454,
                                nil,
                                rHoch, BewMode));
    Inc(Punkte, Hoch5.Calculate(Hexagon531,
                                Hexagon542,
                                Hexagon553,
                                nil,
                                nil,
                                rHoch, BewMode));
    Inc(Punkte, Auf1.Calculate (Hexagon113,
                                Hexagon212,
                                Hexagon311,
                                nil,
                                nil,
                                rAuf,  BewMode));
    Inc(Punkte, Auf2.Calculate (Hexagon124,
                                Hexagon223,
                                Hexagon322,
                                Hexagon421,
                                nil,
                                rAuf,  BewMode));
    Inc(Punkte, Auf3.Calculate (Hexagon135,
                                Hexagon234,
                                Hexagon333,
                                Hexagon432,
                                Hexagon531,
                                rAuf,  BewMode));
    Inc(Punkte, Auf4.Calculate (Hexagon245,
                                Hexagon344,
                                Hexagon443,
                                Hexagon542,
                                nil,
                                rAuf,  BewMode));
    Inc(Punkte, Auf5.Calculate (Hexagon355,
                                Hexagon454,
                                Hexagon553,
                                nil,
                                nil,
                                rAuf,  BewMode));
    Inc(Punkte, Ab1.Calculate  (Hexagon311,
                                Hexagon421,
                                Hexagon531,
                                nil,
                                nil,
                                rAb,   BewMode));
    Inc(Punkte, Ab2.Calculate  (Hexagon212,
                                Hexagon322,
                                Hexagon432,
                                Hexagon542,
                                nil,
                                rAb,   BewMode));
    Inc(Punkte, Ab3.Calculate  (Hexagon113,
                                Hexagon223,
                                Hexagon333,
                                Hexagon443,
                                Hexagon553,
                                rAb,   BewMode));
    Inc(Punkte, Ab4.Calculate  (Hexagon124,
                                Hexagon234,
                                Hexagon344,
                                Hexagon454,
                                nil,
                                rAb,   BewMode));
    Inc(Punkte, Ab5.Calculate  (Hexagon135,
                                Hexagon245,
                                Hexagon355,
                                nil,
                                nil,
                                rAb,   BewMode));
    str(Punkte, s);
    Bewertung.Caption := s;
  end;

procedure TChildForm.BewertungClick(Sender: TObject);
  begin
    Calculate;
  end;

procedure TChildForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    Schliessen;
  end;

procedure TChildForm.Schliessen;
  var     Telegramm : tTelegramm;
          IniFile   : tIniFile;
  begin
    Running := False;
    IniFile := tIniFile.Create(IniName);
    if WindowState = wsNormal then
      begin
        IniFile.WriteInteger(IniChild, IniHeight, Height);
        IniFile.WriteInteger(IniChild, IniWidth,  Width);
      end;
    IniFile.WriteInteger(IniChild, IniState, ord(WindowState));
    IniFile.Free;
    ToPlace := False;
    MainForm.NextWindow;
    if MainForm.MyIPs <> Nil then
      if IPs <> Nil then
        if IPs.Count > 0 then
          if MainForm.MyIPs.Count > 0 then
            if MainForm.MyIPs.IndexOf(IPs[0]) >= 0 then
              begin
                Telegramm.Kennung    := TelegrammEnde;
                Telegramm.EndeHandle := RemoteHandle;
                Telegramm.EndeIp     := Ips[0];
                SendeAllen(Telegramm);
              end;
    MainForm.CheckHosts;
    MainForm.ShowPanel(True);
    MainForm.ChildSchliessen(Self);
    Release;
  end;

procedure TChildForm.SendeSpiel(Ziel : LongInt);
  var     i, h, e   : Integer;
          s         : String;
          Telegramm : tTelegramm;
          Hex       : tHexagon;
  begin
    for i := 0 to Ips.Count - 1 do
      begin
        Telegramm.Kennung        := TelegrammMitspieler;
        Telegramm.MitspielSteine := MainForm.Steine;
        Telegramm.MitspielStdIp  := MainForm.GetStdIp(Ziel, Ips);
        Telegramm.MitspielIp     := Telegramm.MitspielStdIp;
        Telegramm.MitspielHandle := RemoteHandle;
        s                        := Caption;
        if Copy(s, 1, 2) = '\\' then
          begin
            s := Copy(s, 3, length(s));
            s := Copy(s, Pos('\', s) + 1, length(s));
          end;
        StrPCopy(Telegramm.MitspielName,
                 Copy(s, 1, sizeof(Telegramm.MitspielName) - 1));
        MainForm.SendTelegramm(Telegramm, Ziel);
      end;
    Hex := Findcomponent(HexName + '1') as tHexagon;
    if Hex <> Nil then
      Hex := Hex.GetOccupation;
    if Hex <> Nil then
      begin
        s := Copy(Hex.Name, length(HexName) + 1, length(Hex.Name));
        val(s, h, e);
        Telegramm.Kennung       := TelegrammSteinTest;
        Telegramm.GesetztHandle := RemoteHandle;
        Telegramm.GesetztNr     := 1;
        Telegramm.GesetztZiel   := h;
        Telegramm.GesetztIp     := MainForm.GetStdIp(Ziel, Ips);
        MainForm.SendTelegramm(Telegramm, Ziel);
      end;
  end;

procedure TChildForm.Lay(Stein, Ziel: tHexagon);
  var     Occupied  : tHexagon;
          Telegramm : tTelegramm;
          s         : String;
          i, e      : Integer;
  begin
    Occupied := Stein.GetOccupation;
    if Occupied <> Nil then
      Occupied.FreeOccupation;
    Stein.LayAt(Ziel.Top, Ziel.Left);
    Ziel.Occupy(Stein);
    Stein.Occupy(Ziel);
    if MainForm.MyIps <> Nil then
      if MainForm.MyIps.Count > 0 then
        if MainForm.MyIps.IndexOf(Ips[0]) >= 0 then
          begin
            s := Ziel.Name;
            s := Copy(s, length(HexName) + 1, length(s));
            val(s, i, e);
            Telegramm.Kennung       := TelegrammSteinTest;
            Telegramm.GesetztHandle := RemoteHandle;
            Telegramm.GesetztNr     := Hexagon;
            Telegramm.GesetztZiel   := i;
            Telegramm.GesetztIp     := Ips[0];
            SendeAllen(Telegramm);
          end;
    if BtnOk.Visible then
      begin
        BtnOk.Enabled := True;
        BtnOk.SetFocus;
      end;
    Calculate;
  end;

procedure TChildForm.Drop(Sender: TObject);
  var     s     : String;
          Stein : tHexagon;
  begin
   str(Hexagon, s);
   Stein := FindComponent(HexName + s) as tHexagon;
   if Caption <> 'PC' then
     if Copy(Caption, 1, 2) <> '\\' then
       if BtnOk.enabled or (Stein.GetOccupation = Nil) then
         Lay(Stein, Sender as tHexagon);
  end;

procedure TChildForm.MouseDownHex(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  begin
    if Shift = [] then;
    if x = 0 then;
    if y = 0 then;
    if Button = mbRight Then
      ToConfirm := Sender as tHexagon
    else
      if (Caption <> 'PC')
         and (Copy(Caption, 1, 2) <> '\\')
         and ((Sender as tHexagon).Style = hxHighlight)
      Then
        begin
          ToDrag       := (Sender as tHexagon);
          BeforeDrag.x := ToDrag.Left;
          BeforeDrag.y := ToDrag.Top;
          ToDrag.BringToFront;
          GetCursorPos(DragOrigin);
        end;
  end;

procedure TChildForm.MouseUpSonst(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  begin
    if Shift = [] then;
    if x = 0 then;
    if y = 0 then;
    BringToFront;
    if Button = mbRight then
      if Caption = 'PC' Then
        begin
          if BtnOk.enabled then
            SteinOk;
        end
      else
        if Copy(Caption, 1, 2) <> '\\' Then
          if Sender = ToConfirm Then
            begin
              Drop(Sender);
              if BtnOk.enabled then
                SteinOk;
            end;
  end;

procedure TChildForm.MouseUpStein(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
  begin
    if Shift = [] then;
    if x = 0 then;
    if y = 0 then;
    BringToFront;
    if ToDrag <> Nil then
      begin
        ToDrag.Left := BeforeDrag.x;
        ToDrag.Top  := BeforeDrag.y;
      end;
    if Button = mbRight Then
      begin
        if BtnOk.Enabled then
          if Caption = 'PC' then
            SteinOk
          else
            if Sender = ToConfirm then
              if (Sender as tHexagon).Style = HxHighlight Then
                SteinOk;
      end
    else
      if Button = mbLeft then
        ToDrag := Nil;
  end;

procedure TChildForm.FormCreate(Sender: TObject);
  begin
    case SysLocale.PriLangID of
      Lang_German:
    else
      Bewertung.Items[0] := '&points';
      Bewertung.Items[1] := '&quality';
      BitBtn.Hint        := 'Message to owner';
    end;
    Start     := True;
    ToConfirm := Nil;
    ToDrag    := Nil;
    Color     := GlobBackground;
  end;

procedure TChildForm.FormResize(Sender: TObject);
  begin
    NewSize;
  end;

procedure TChildForm.NewSize;
  var     i, w, h : Integer; 
  begin
    h := ClientHeight;
    w := (h * 540) div 280;
    if w > ClientWidth then
      begin
        w := ClientWidth;
        h := (w * 280) div 540;
      end;
    Hoch1.Left := (49 * w) div 100;
    Hoch1.Top  := (24 * h) div 100 - Hoch1.Height;
    Hoch2.Left := (57 * w) div 100;
    Hoch2.Top  := (14 * h) div 100 - Hoch2.Height;
    Hoch3.Left := (65 * w) div 100;
    Hoch3.Top  := ( 5 * h) div 100 - Hoch3.Height;
    Hoch4.Left := (73 * w) div 100;
    Hoch4.Top  := (14 * h) div 100 - Hoch4.Height;
    Hoch5.Left := (81 * w) div 100;
    Hoch5.Top  := (24 * h) div 100 - Hoch5.Height;
    Ab1.Left   := (85 * w) div 100;
    Ab1.Top    := (36 * h) div 100;
    Ab2.Left   := (85 * w) div 100;
    Ab2.Top    := (55 * h) div 100;
    Ab3.Left   := (85 * w) div 100;
    Ab3.Top    := (74 * h) div 100;
    Ab4.Left   := (77 * w) div 100;
    Ab4.Top    := (83 * h) div 100;
    Ab5.Left   := (69 * w) div 100;
    Ab5.Top    := (93 * h) div 100;
    Auf1.Left  := (47 * w) div 100 - Auf1.Width;
    Auf1.Top   := (36 * h) div 100;
    Auf2.Left  := (47 * w) div 100 - Auf2.Width;
    Auf2.Top   := (55 * h) div 100;
    Auf3.Left  := (47 * w) div 100 - Auf3.Width;
    Auf3.Top   := (74 * h) div 100;
    Auf4.Left  := (55 * w) div 100 - Auf4.Width;
    Auf4.Top   := (83 * h) div 100;
    Auf5.Left  := (63 * w) div 100 - Auf5.Width;
    Auf5.Top   := (93 * h) div 100;
    for i := 0 to ControlCount - 1 do
      if Controls[i] is tHexagon then
        (Controls[i] as tHexagon).HexResize(h, w);
    Bewertung.Left := w - Bewertung.Width - Rand;
    BtnOk.Left     := w - BtnOk.Width     - Rand;
    BtnOk.Top      := h - BtnOk.Height    - Rand;
    BitBtn.Left    := w - BitBtn.Width    - Rand;
    BitBtn.Top     := BtnOk.Top;
  end;

procedure TChildForm.SteinGesetzt(Nr         : ShortInt;
                                  Ziel       : Word;
                                  Endgueltig : Boolean);
  var     s, t : String;
  begin
    if word(Nr) = Hexagon then
      begin
        str(Nr,   s);
        str(Ziel, t);
        Lay(FindComponent(HexName + s) as tHexagon,
            FindComponent(HexName + t) as tHexagon);
        if Endgueltig then
          SteinOk;
      end
    else
      if (word(Nr) + 1 = Hexagon) or
         (word(Nr) = ZuSetzen) and (Hexagon = Gesamtsteine) then
        begin
          str(Nr,   s);
          str(Ziel, t);
          if (FindComponent(HexName + s) as tHexagon).GetOccupation
             <> FindComponent(HexName + t) as tHexagon
          then
            Schliessen;
        end
      else
        Schliessen;
  end;

procedure TChildForm.MouseMoveStein(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
  var p : tPoint;
      i : Integer;
      c : tHexagon;
  begin
    if Shift = [] then;
    if x = 0 then;
    if y = 0 then;
    if ToDrag <> Nil then
      begin
        p.x := 0;
        GetCursorPos(p);
        ToDrag.Left := p.x - DragOrigin.x + BeforeDrag.x;
        ToDrag.Top  := p.y - DragOrigin.y + BeforeDrag.y;
        i := 0;
        while i < ControlCount do
          begin
            if Controls[i] is tHexagon then
              begin
                c := Controls[i] as tHexagon;
                if c.Style = hxEmpty then
                  if c.GetOccupation = Nil then
                    if c.ClientOrigin.x + c.Width div 4 <= p.x then
                      if c.ClientOrigin.x + 3 * c.Width div 4 >= p.x then
                        if c.ClientOrigin.y + c.Height div 4 <= p.y then
                          if c.ClientOrigin.y + 3 * c.Height div 4>= p.y then
                            begin
                              Lay(ToDrag, c);
                              BeforeDrag.x := ToDrag.Left;
                              BeforeDrag.y := ToDrag.Top;
                              DragOrigin   := p;
                              i            := ControlCount;
                            end;
              end;
            inc(i);
          end;
      end;
  end;

procedure TChildForm.FormPaint(Sender: TObject);
  const   TitleHeight = 32;
  var     IniFile     : tIniFile;
          t, l, h, w  : Integer;
          s           : tWindowState;
  begin
    if Start then
      begin
        Start   := False;
        Running := True;
        IniFile := tIniFile.Create(IniName);
        {$ifdef fpc}
          t := MainForm.Top + MainForm.Height + TitleHeight;
          l := MainForm.Left;
        {$else}
          t := 0;
          l := 0;
        {$endif}
        t := IniFile.ReadInteger(IniChild, IniTop,    t);
        l := IniFile.ReadInteger(IniChild, IniLeft,   l);
        h := IniFile.ReadInteger(IniChild, IniHeight, Height);
        w := IniFile.ReadInteger(IniChild, IniWidth,  Width);
        s := tWindowState(
               IniFile.ReadInteger(IniChild, IniState, ord(wsNormal)));
        {$ifdef fpc}
          if h > Screen.Height then
            h := Screen.Height;
          if w > Screen.Width then
            w := Screen.Width;
          if t + h > Screen.Height then
            t := MainForm.Top + MainForm.Height;
          if l + w > Screen.Width then
            l := MainForm.Left;
          if t + h > Screen.Height then
            t := 0;
          if l + w > Screen.Width then
            l := 0;
        {$else}
          if h > MainForm.ClientHeight - MainForm.Toolbar.Height - 4 then
            h := MainForm.ClientHeight - MainForm.Toolbar.Height - 4;
          if w > MainForm.ClientWidth then
            w := MainForm.ClientWidth;
          if t + h > MainForm.ClientHeight - MainForm.Toolbar.Height then
            t := 0;
          if l + w > MainForm.ClientWidth then
            l := 0;
        {$endif}
        Top    := t;
        Left   := l;
        Height := h;
        Width  := w;
        {$ifdef fpc}
          inc(t, TitleHeight);
          inc(l, TitleHeight);
        {$else}
          inc(t, Height - ClientHeight);
          inc(l, Height - ClientHeight);
        {$endif}
        WindowState := s;
        IniFile.WriteInteger(IniChild, IniTop,    t);
        IniFile.WriteInteger(IniChild, IniLeft,   l);
        IniFile.WriteInteger(IniChild, IniHeight, h);
        IniFile.WriteInteger(IniChild, IniWidth,  w);
        IniFile.Free;
        NewSize;
      end;
  end;

procedure TChildForm.BitBtnClick(Sender: TObject);
  var f : tChatForm;
  begin
    f := MainForm.StartChat;
    if f <> Nil then
      begin
        if Ips.Count > 0 then
          f.ComboBox.ItemIndex :=
            f.ComboBox.Items.IndexOf(Inet_NtoA(tInAddr(Ips[0])));
        f.Edit.SetFocus;
        f.BringToFront;
      end;
  end;

procedure TChildForm.FormDestroy(Sender: TObject);
  begin
    IPs.Free;
    Release;
  end;

end.
