unit colors;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
    LCLIntf,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ExtCtrls,
  StdCtrls,
  Buttons,
  IniFiles,
  Zusatz,
  Hexagon;

type
  TColorsForm      = class(TForm)
    Hexagon1       : tHexagon;
    Hexagon2       : tHexagon;
    Hexagon3       : tHexagon;
    Hexagon4       : tHexagon;
    Hexagon5       : tHexagon;
    Hexagon6       : tHexagon;
    Hexagon7       : tHexagon;
    Hexagon8       : tHexagon;
    Hexagon9       : tHexagon;
    Hexagon10      : tHexagon;
    Hexagon11      : tHexagon;
    Hexagon12      : tHexagon;
    Hexagon13      : tHexagon;
    Hexagon14      : tHexagon;
    Hexagon15      : tHexagon;
    Hexagon16      : tHexagon;
    Hexagon17      : tHexagon;
    Hexagon18      : tHexagon;
    Hexagon19      : tHexagon;
    Hexagon20      : tHexagon;
    Hexagon21      : tHexagon;
    Hexagon22      : tHexagon;
    Hexagon23      : tHexagon;
    Hexagon24      : tHexagon;
    Hexagon25      : tHexagon;
    Hexagon26      : tHexagon;
    Hexagon27      : tHexagon;
    ColorDialog    : TColorDialog;
    OkButton       : TButton;
    Farbe          : TRadioGroup;
    FarbeButton    : TButton;
    Bar1           : tBar;
    Bar2           : tBar;
    Bar3           : tBar;
    Bar4           : tBar;
    Bar5           : tBar;
    Bar6           : tBar;
    Bar7           : tBar;
    Bar8           : tBar;
    Bar9           : tBar;
    BarBackground1 : tBar;
    BarShadow      : tBar;
    BarLight1      : tBar;
    WindowsButton  : TButton;
    StandardButton : TButton;
    BarLight2      : tBar;
    BarBackground2 : tBar;
    procedure        FormCreate(Sender: TObject);
    procedure        StartColor(Sender: TObject);
    procedure        MySetColor(Sender: TObject);
    procedure        WindowsColor(Sender: TObject);
    procedure        ResetLinien(Sender: TObject);
    procedure        ToFront(Sender: TObject);
    procedure        FormClose(Sender: TObject; var CloseAction: TCloseAction);
    {$ifdef fpc}
      procedure      EditColor(Sender: TObject; Button: TMouseButton);
      procedure      HiLight(Sender: TObject);
      procedure      UnLight(Sender: TObject);
      procedure      Press(Sender: TObject);
    {$else}
      procedure      EditColor(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
      procedure      HiLight(Sender: TObject; Shift: TShiftState; X, Y: Integer);
      procedure      UnLight(Sender: TObject; Shift: TShiftState; X, Y: Integer);
      procedure      Press(Sender: TObject; Button: TMouseButton;
                           Shift: TShiftState; X, Y: Integer);
    {$endif}
    procedure        FormShow(Sender: TObject);
    procedure        OkButtonClick(Sender: TObject);
  private
    NextDialog     : Boolean;
    LineColors     : tLineColors;
    Background,
    Light,
    Shadow         : tColor;
    procedure        UnLightAll;
    procedure        NewColors;
  end;

var
  ColorsForm       : TColorsForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

procedure TColorsForm.NewColors;
  var i : Integer;
  begin
    Color := Background;
    for i := 0 to ControlCount - 1 do
      if Controls[i] is tHexagon then
        (Controls[i] as tHexagon).NewColors(
          LineColors, Background, Light, Shadow)
      else
        if Controls[i] is tBar then
          (Controls[i] as tBar).NewColors(
             LineColors, Background, Light, Shadow);
  end;

procedure TColorsForm.FormCreate(Sender: TObject);
  begin
    NextDialog := False;
    case SysLocale.PriLangID of
      Lang_German:
    else
      Caption                := 'Hextension colors';
      Farbe.Caption          := '&Color';
      Farbe.Items[9]         := 'Background';
      Farbe.Items[10]        := 'Shadow';
      Farbe.Items[11]        := 'Light';
      FarbeButton.Caption    := '&Adjust';
      WindowsButton.Caption  := '&Windows Background';
      StandardButton.Caption := '&Default line colors';
    end;
    LoadFormFromIni(Self, Name);
  end;

procedure TColorsForm.StartColor(Sender: TObject);
  const   Shading = $40;
  var     i,
          r, g, b : Integer;
  begin
    ColorDialog.CustomColors.Clear;
    for i := 1 to 9 do
      ColorDialog.CustomColors.Add(
        'Color' + chr(i + ord('A') - 1)
        + '=' + IntToHex(ColorToRgb(LineColors[i]), 6));
    ColorDialog.CustomColors.Add('ColorJ=' +
      IntToHex(ColorToRgb(Background), 6));
    ColorDialog.CustomColors.Add('ColorK=' +
      IntToHex(ColorToRgb(Shadow),     6));
    ColorDialog.CustomColors.Add('ColorL=' +
      IntToHex(ColorToRgb(Light),      6));
    if Farbe.ItemIndex < 9 then
      ColorDialog.Color := LineColors[Farbe.ItemIndex + 1]
    else
      case Farbe.ItemIndex of
         9 : ColorDialog.Color := Background;
        10 : ColorDialog.Color := Shadow;
        11 : ColorDialog.Color := Light;
      end;
    NextDialog := True;
    ColorDialog.execute;
    NextDialog := False;
    if Farbe.ItemIndex < 9 then
      LineColors[Farbe.ItemIndex + 1] := ColorDialog.Color
    else
      case Farbe.ItemIndex of
         9 : begin
               Background := ColorDialog.Color;
               r := GetRValue(ColorToRGB(ColorDialog.Color)) + Shading;
               g := GetGValue(ColorToRGB(ColorDialog.Color)) + Shading;
               b := GetBValue(ColorToRGB(ColorDialog.Color)) + Shading;
               if r > $ff then
                 r := $ff;
               if g > $ff then
                 g := $ff;
               if b > $ff then
                 b := $ff;
               Light := RGB(r, g, b);
               r := GetRValue(ColorToRGB(ColorDialog.Color)) - Shading;
               g := GetGValue(ColorToRGB(ColorDialog.Color)) - Shading;
               b := GetBValue(ColorToRGB(ColorDialog.Color)) - Shading;
               if r < 0 then
                 r := 0;
               if g < 0 then
                 g := 0;
               if b < 0 then
                 b := 0;
               Shadow := RGB(r, g, b);
             end;
        10 : Shadow := ColorDialog.Color;
        11 : Light  := ColorDialog.Color;
      end;
    NewColors;
  end;

procedure TColorsForm.MySetColor(Sender: TObject);
  var     s     : String;
          i,
          Error : Integer;
  begin
    s := Copy((Sender as tBar).Name, 4, $ff);
    val(s, i, Error);
    if Error = 0 Then
      Farbe.ItemIndex := i - 1
    else
      if s = 'Background1' Then
        Farbe.ItemIndex := 9
      else if s = 'Shadow' Then
        Farbe.ItemIndex := 10
      else if s = 'Light1' Then
        Farbe.ItemIndex := 11;
  end;

procedure TColorsForm.WindowsColor(Sender: TObject);
  begin
    InitBackground(Background, Light, Shadow);
    NewColors;
  end;

procedure TColorsForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  var     IniFile : tIniFile;
          i       : Integer;
          s       : String;
  begin
    if CloseAction = caFree then;
    IniFile := tIniFile.Create(IniName);
    for i := 1 to 9 do
      begin
        str(i, s);
        IniFile.WriteString(IniColors, IniLine + s,
                            '0x' + IntToHex(Linecolors[i], 6));
      end;
    IniFile.WriteString(IniColors, IniBackground,
                        '0x' + IntToHex(Background, 8));
    IniFile.WriteString(IniColors, IniShadow,
                        '0x' + IntToHex(Shadow,     8));
    IniFile.WriteString(IniColors, IniLight,
                        '0x' + IntToHex(Light,      8));
    IniFile.Free;
    SaveFormToIni(Self, Name);
  end;

procedure TColorsForm.ResetLinien(Sender: TObject);
  begin
    InitLinien(LineColors);
    NewColors;
  end;

procedure TColorsForm.ToFront(Sender: TObject);
  begin
    if not NextDialog Then
      BringToFront;
  end;

{$ifdef fpc}
  procedure TColorsForm.EditColor(Sender: TObject; Button: TMouseButton);
{$else}
  procedure TColorsForm.EditColor(Sender: TObject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
{$endif}
  var     s     : String;
          i,
          Error : Integer;
  begin
    if (Sender as tBar).Up Then
      if Button = mbRight then
        begin
          s := Copy((Sender as tBar).Name, 4, $ff);
          val(s, i, Error);
          if Error = 0 Then
            Farbe.ItemIndex := i - 1
          else
            if s = 'Background1' Then
              Farbe.ItemIndex := 9
            else if s = 'Shadow' Then
              Farbe.ItemIndex := 10
            else if s = 'Light1' Then
              Farbe.ItemIndex := 11;
          StartColor(Sender);
        end;
  end;

procedure TColorsForm.UnLightAll;
  begin
    Bar1.UnLight;
    Bar2.UnLight;
    Bar3.UnLight;
    Bar4.UnLight;
    Bar5.UnLight;
    Bar6.UnLight;
    Bar7.UnLight;
    Bar8.UnLight;
    Bar9.UnLight;
    BarBackground1.Unlight;
    BarShadow.Unlight;
    BarLight1.Unlight;
  end;

{$ifdef fpc}
  procedure TColorsForm.HiLight(Sender: TObject);
{$else}
  procedure TColorsForm.HiLight(Sender: TObject; Shift: TShiftState; X,
                                Y: Integer);
{$endif}
  begin
    (Sender as tBar).Mark;
    UnLightAll;
    (Sender as tBar).HiLight;
  end;

{$ifdef fpc}
  procedure TColorsForm.UnLight(Sender: TObject);
{$else}
  procedure TColorsForm.UnLight(Sender: TObject; Shift: TShiftState; X,
                                Y: Integer);
{$endif}
  begin
    UnLightAll;
  end;

{$ifdef fpc}
  procedure TColorsForm.Press(Sender: TObject);
{$else}
  procedure TColorsForm.Press(Sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
{$endif}
  begin
    (Sender as tBar).Down;
  end;

procedure TColorsForm.FormShow(Sender: TObject);
  begin
    LineColors := GlobLineColors;
    Background := GlobBackground;
    Light      := GlobLight;
    Shadow     := GlobShadow;
    NewColors;
  end;

procedure TColorsForm.OkButtonClick(Sender: TObject);
  begin
    GlobLineColors := LineColors;
    GlobBackground := Background;
    GlobLight      := Light;
    GlobShadow     := Shadow;
    ModalResult    := mrOk;
  end;

end.
