unit idee;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifndef Unix}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
    LConvEncoding,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  Hexagon,
  WolfUtil,
  Zusatz;

type
  TIdeaForm   = class(TForm)
    Button1   : TButton;
    Label1    : TLabel;
    Label2    : TLabel;
    Label3    : TLabel;
    Label4    : TLabel;
    Label5    : TLabel;
    Label6    : TLabel;
    Label7    : TLabel;
    procedure   FormCreate(Sender: TObject);
    procedure   ToFront(Sender: TObject);
    procedure   FormClose(Sender: TObject; var CloseAction: TCloseAction);
  end;

var
  IdeaForm: TIdeaForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

procedure TIdeaForm.FormCreate(Sender: TObject);
  begin
    case SysLocale.PriLangID of
      Lang_German:
    else
      Caption        := 'Hextension idea';
      Label1.caption := 'The game''s idea is by Peter Burley.';
      Label3.caption := 'It is published as game in a box no. 71309.9';
      Label4.caption := CP1252toSystem('named "Take it easy"  1994 '
                        + 'by F. X. Schmid Games, D-83209 Prien');
      Label5.caption := 'with the layout by Franz Vohwinkel.';
      Label6.caption := '1994 it was preselected for';
      Label7.caption := 'the election to the game of the year.';
    end;
    LoadFormFromIni(Self, Name);
  end;

procedure TIdeaForm.ToFront(Sender: TObject);
  begin
    BringToFront;
  end;

procedure TIdeaForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self, Name);
  end;

end.
