unit main;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    Sockets,
    LibC,
    BaseUnix,
  {$else}
    {$ifdef fpc}
      Sockets,
    {$endif}
    WinSock,
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
    LCLType,
  {$else}
    StdCtrls,
  {$endif}
  Forms,
  ExtCtrls,
  Menus,
  Controls,
  Buttons,
  Classes,
  IniFiles,
  SysUtils,
  Graphics,
  zusatz,
  WolfUtil,
  author,
  idee,
  optimum,
  ziel,
  hexagon,
  child,
  names,
  score,
  colors,
  thread,
  chat;

const
  UDPService            = 'Take_it_easy';

type

  { TMainForm }

  TMainForm             = class(TForm)
    MainMenu            : TMainMenu;
    MenuSpiel           : TMenuItem;
    MenuNeu             : TMenuItem;
    MenuHigh            : TMenuItem;
    MenuFenster         : TMenuItem;
    MenuUeberlappend    : TMenuItem;
    MenuNebeneinander   : TMenuItem;
    MenuSymboleAnordnen : TMenuItem;
    MenuAmZug           : TMenuItem;
    MenuChat            : TMenuItem;
    MenuEinstellung     : TMenuItem;
    MenuFarben          : TMenuItem;
    MenuNetzwerk        : TMenuItem;
    MenuShortcut        : TMenuItem;
    MenuInfo            : TMenuItem;
    MenuEignung         : TMenuItem;
    MenuIdee            : TMenuItem;
    MenuProgramm        : TMenuItem;
    MenuZiel            : TMenuItem;
    MenuOpt             : TMenuItem;
    Toolbar             : TPanel;
    Panel               : TPanel;
    BtnNeu              : TBitBtn;
    BtnNeuAtn           : TBitBtn;
    BtnHighscore        : TBitBtn;
    BtnNext             : TBitBtn;
    BtnFarben           : TBitBtn;
    BtnEignung          : TBitBtn;
    BtnIdee             : TBitBtn;
    BtnProg             : TBitBtn;
    BtnZiel             : TBitBtn;
    BtnOpt              : TBitBtn;
    Hexagon113          : tHexagon;
    Hexagon124          : tHexagon;
    Hexagon135          : tHexagon;
    Hexagon212          : tHexagon;
    Hexagon223          : tHexagon;
    Hexagon234          : tHexagon;
    Hexagon245          : tHexagon;
    Hexagon311          : tHexagon;
    Hexagon322          : tHexagon;
    Hexagon333          : tHexagon;
    Hexagon344          : tHexagon;
    Hexagon355          : tHexagon;
    Hexagon421          : tHexagon;
    Hexagon432          : tHexagon;
    Hexagon443          : tHexagon;
    Hexagon454          : tHexagon;
    Hexagon531          : tHexagon;
    Hexagon542          : tHexagon;
    Hexagon553          : tHexagon;
    Hexagon11           : tHexagon;
    Hexagon12           : tHexagon;
    Hexagon13           : tHexagon;
    Hexagon14           : tHexagon;
    Hexagon15           : tHexagon;
    Hexagon16           : tHexagon;
    Hexagon17           : tHexagon;
    Hexagon18           : tHexagon;
    Hexagon19           : tHexagon;
    Hexagon20           : tHexagon;
    Hexagon21           : tHexagon;
    Hexagon22           : tHexagon;
    Hexagon23           : tHexagon;
    Hexagon24           : tHexagon;
    Hexagon25           : tHexagon;
    Hexagon26           : tHexagon;
    Hexagon27           : tHexagon;
    Timer               : TTimer;
    Bewertung           : TRadioGroup;
    Auf1                : tPkteLabel;
    Auf2                : tPkteLabel;
    Auf3                : tPkteLabel;
    Auf4                : tPkteLabel;
    Auf5                : tPkteLabel;
    Ab5                 : tPkteLabel;
    Ab4                 : tPkteLabel;
    Ab3                 : tPkteLabel;
    Ab2                 : tPkteLabel;
    Ab1                 : tPkteLabel;
    Hoch5               : tPkteLabel;
    Hoch4               : tPkteLabel;
    Hoch3               : tPkteLabel;
    Hoch2               : tPkteLabel;
    Hoch1               : tPkteLabel;
    procedure             BtnNeuClick(Sender: TObject);
    procedure             FormCreate(Sender: TObject);
    procedure             ShowHighScore(Sender: TObject);
    procedure             FarbenEinstellen(Sender: TObject);
    procedure             ShowAutor(Sender: TObject);
    procedure             ShowIdee(Sender: TObject);
    procedure             Optimum(Sender: TObject);
    procedure             ShowStrategie(Sender: TObject);
    procedure             TimerTimer(Sender: TObject);
    procedure             MenuUeberlappendClick(Sender: TObject);
    procedure             MenuNebeneinanderClick(Sender: TObject);
    procedure             MenuSymboleAnordnenClick(Sender: TObject);
    procedure             BtnNextClick(Sender: TObject);
    procedure             FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure             FormResize(Sender: TObject);
    procedure             ShowEignung(Sender: TObject);
    procedure             BewertungClick(Sender: TObject);
    procedure             MenuNetzwerkClick(Sender: TObject);
    procedure             MenuShortcutClick(Sender: TObject);
    procedure             MenuChatClick(Sender: TObject);
    procedure             FormShow(Sender: TObject);
    procedure             FormDestroy(Sender: TObject);
  private
    Start,
    Blink               : Boolean;
    HighScore           : tHighScore;
    NetworkThread       : tNetworkThread;
    OptimumDemo         : Word;
    MyHostName          : Array[0..40] of char;
    Children            : tList;
    FullHeight          : Integer;
    procedure             InsertScore(Player : String; Punkte: Word);
    procedure             EnableNeu(NeuEnabled : Boolean);
    procedure             Save;
    procedure             NewSize;
    procedure             NeueSteine;
    procedure             Calculate;
    function              InitNetwork : String;
    procedure             EditNetwork;
    Procedure             StopChat;
    procedure             DeleteHost(Rechner : LongInt);
    procedure             NewColors;
    function              GetMyAdapter(InetSocket : tSocket;
                                       Device     : String) : Boolean;
    function              GetMyAdapters(InetSocket : tSocket;
                                        Devices    : String) : Boolean;
    Function              GetMyIps : Boolean;
  public
    Hosts,
    MyIps               : tLongIntList;
    NetworkState        : tNetworkState;
    UDPPort             : Word;
    UDPProto            : SmallInt;
    Steine              : tSteine;
    function              StartChat : tChatForm;
    function              NeuerSpieler(NeuIp,
                                       NeuStdIp  : LongInt;
                                       Player    : String;
                                       NeuHandle : tHandle) : tChildForm;
    procedure             Anfrage(AnfrageIp : LongInt; Antwort : Boolean);
    function              ReceiveSteine(RemoteIp     : LongInt;
                                        RemoteSteine : tSteine) : Boolean;
    procedure             NextWindow;
    procedure             SendTelegramm(Telegramm   : tTelegramm;
                                        Zielrechner : LongInt);
    procedure             DeletePlayer(DeleteIp : LongInt; DeleteHandle : tHandle);
    procedure             SteinGesetzt(GesetztIp     : LongInt;
                                       GesetztHandle : tHandle;
                                       GesetztNr     : ShortInt;
                                       GesetztZiel   : Word;
                                       Endgueltig    : Boolean);
    procedure             ThreadReady;
    procedure             ThreadBlocked;
    procedure             CheckHosts;
    Procedure             Chat(ChatIp : LongInt; ChatStdIp : LongInt; ChatText : String);
    procedure             ShowPanel(PanelVisible : Boolean);
    Procedure             NotifyAddress(Ip : LongInt);
    procedure             ThreadMessage(s : String);
    function              GetStdIp(Ip : LongInt; Ips : tLongIntList) : LongInt;
    procedure             ChildSchliessen(Form : tForm);
    function              ChildCount : Integer;
    function              Child(i : Integer) : tForm;
  end;

var
  MainForm : TMainForm;

implementation

uses
  {$ifndef fpc}
    link,
  {$endif}
  Port;

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

function TMainForm.ChildCount : Integer;
  begin
    {$ifdef fpc}
      ChildCount := Children.Count;
    {$else}
      ChildCount := MDIChildCount;
    {$endif}
  end;

function TMainForm.Child(i : Integer) : tForm;
  begin
    {$ifdef fpc}
      Child := tForm(Children[i]);
    {$else}
      Child := MDIChildren[i];
    {$endif}
  end;

function TMainForm.GetStdIp(Ip : LongInt; Ips : tLongIntList) : LongInt;
  var    i     : Integer;
         StdIp,
         Min,
         X     : LongInt;
  begin
    StdIp := LongInt(InAddr_None);
    Min   := LongInt($FFFFFFFF);
    if Ips <> Nil then
      if Ips.Count > 0 then
        begin
          StdIp := Ips[0];
          for i := 1 to Ips.Count - 1 do
            begin
              x := Ips[i] xor Ip;
              if x < Min then
                begin
                  StdIp := Ips[i];
                  Min   := x;
                end;
            end;
        end;
    GetStdIp := StdIp;
  end;

procedure TMainForm.ThreadMessage(s : String);
  begin
    MsgBox(s, Caption, mb_IconHand);
  end;

function TMainForm.GetMyAdapter(InetSocket : tSocket; Device : String) : Boolean;
  {$ifdef Unix}
    var  IFRequest : IFReq;
  {$endif}
  begin
    GetMyAdapter := False;
    {$ifdef Unix}
      StrPCopy(IFRequest.ifr_ifrn.ifrn_name,
               Copy(Device, 1, sizeof(IFRequest.ifr_ifrn.ifrn_name) - 1));
      if fpIoCtl(InetSocket, SIOCGIFADDR, @IFRequest) >= 0 then
        begin
          MyIps.Add(LongInt(IFRequest.ifr_ifru.ifru_addr.sin_addr));
          GetMyAdapter := TRUE;
        end;
    {$else}
      if InetSocket = invalid_socket then;
      if Device     = '' then;
    {$endif}
  end;
  
function TMainForm.GetMyAdapters(InetSocket : tSocket; Devices : String) : Boolean;
  var    n : Integer;
  begin
    n := 0;
    while GetMyAdapter(InetSocket, Devices + IntToStr(N)) do
      inc(n);
    GetMyAdapters := n > 0;
  end;
  
function TMainForm.GetMyIps: Boolean;
  {$ifdef Unix}
    var  InetSocket : tSocket;
  {$else}
    var  i       : Integer;
         HostEnt : pHostEnt;
         ip      : LongInt;
  {$endif}
  begin
    GetMyIps := False;
    If MyIps <> Nil then
      {$ifdef Unix}
        If MyIps.Count > 0 then
          GetMyIps := True
        else
          begin
            InetSocket := fpSocket(AF_Inet, LongInt(Sock_Stream), 0);
            if InetSocket > 0 then
              begin
                if GetMyAdapters(InetSocket, 'eth')
                   or GetMyAdapters(InetSocket, 'wlan')
                then
                  GetMyIps := TRUE;
                CloseSocket(InetSocket);
              end;
          end;
      {$else}
        begin
          HostEnt  := GetHostByName(MyHostName);
          if HostEnt <> Nil then
            begin
              GetMyIps := True;
              i        := 0;
              while pAddrList(HostEnt^.h_addr_list)^[i] <> Nil do
                begin
                  ip := pAddrList(HostEnt^.h_addr_list)^[i]^.s_addr;
                  if MyIps.IndexOf(ip) < 0 then
                    MyIps.add(ip);
                  inc(i);
                end;
            end;
        end;
      {$endif}
  end;


function TMainForm.ReceiveSteine(RemoteIp     : LongInt;
                                 RemoteSteine : tSteine) : Boolean;
  var    Uebernehmen : Boolean;
         i           : Integer;
  begin
    ReceiveSteine := False;
    if MyIps <> Nil then
      if MyIps.IndexOf(RemoteIp) < 0 then
        begin
          Uebernehmen := True;
          for i := 0 to ChildCount - 1 do
            if Child(i) is tChildForm then
              Uebernehmen := False;
          if Uebernehmen then
            begin
              Steine        := RemoteSteine;
              ReceiveSteine := True;
            end
          else
            if CompareMem(@Steine, @RemoteSteine, sizeof(Steine)) then
              ReceiveSteine := True;
        end;
  end;

function TMainForm.NeuerSpieler(NeuIp,
                                NeuStdIp  : LongInt;
                                Player    : String;
                                NeuHandle : tHandle) : tChildForm;
  var    i,
         Count     : Integer;
         Telegramm : tTelegramm;
         Form, f   : tChildForm;
         b         : Boolean;
  begin
    NeuerSpieler := Nil;
    Form         := Nil;
    ShowPanel(False);
    if NeuIp <> 0 then
      NotifyAddress(NeuIp);
    b := BtnNeu.enabled;
    if BtnNeu.enabled then
      for i := 0 to ChildCount - 1 do
        if Child(i) is tChildForm then
          begin
            f := Child(i) as tChildForm;
            if f.Ips <> Nil then
              if f.Ips.IndexOf(NeuStdIp) >= 0 then
                if f.RemoteHandle = NeuHandle then
                  begin
                    b := False;
                    if f.Ips.IndexOf(NeuIp) < 0 then
                      f.Ips.Add(NeuIp);
                  end;
          end;
    if b then
      Form := tChildForm.Create(Self);
    if Form <> Nil then
      begin
        Form.Running := False;
        Form.Ips     := tLongIntList.Create;
        if Form.Ips = Nil then
          begin
            Form.Release;
            Form := Nil;
          end;
        {$ifdef fpc}
          if Form <> Nil then
            Children.add(Form);
        {$endif}
      end;
    if Form <> Nil then
      begin
        NeuerSpieler := Form;
        Form.Init(Steine);
        If NeuIp = 0 then
          begin
            Form.BitBtn.Visible := False;
            Form.Caption        := Player;
            Form.RemoteHandle   := Form.Handle;
            if MyIps <> Nil then
              For i := 0 to MyIps.Count - 1 do
                Form.Ips.Add(MyIps[i]);
            Telegramm.Kennung        := TelegrammMitspieler;
            Telegramm.MitspielSteine := Steine;
            Telegramm.MitspielStdIp  := NeuStdIP;
            Telegramm.MitspielIp     := NeuIP;
            Telegramm.MitspielHandle := Form.RemoteHandle;
            StrPCopy(Telegramm.MitspielName,
                     Copy(Player, 1, sizeof(Telegramm.MitspielName) - 1));
            if Hosts <> Nil then
              if MyIps <> Nil then
                for i := Hosts.Count - 1 downto 0 do
                  begin
                    Telegramm.MitspielStdIp := GetStdIp(Hosts[i], MyIps);
                    Telegramm.MitspielIp    := Telegramm.MitspielStdIp;
                    SendTelegramm(Telegramm, Hosts[i]);
                  end;
          end
        else
          begin
            Form.BtnOk.Visible := False;
            Form.Caption       := '\\' + Inet_NtoA(tInAddr(NeuIp))
                                  + '\' + Player;
            Form.RemoteHandle  := NeuHandle;
            Form.Ips.Add(NeuStdIp);
            if NeuIp <> NeuStdIp then
              Form.Ips.Add(NeuIp);
            b := True;
            for i := 0 to ChildCount - 1 do
              if Child(i) is tChildForm then
                if (Child(i) as tChildForm).Ips.IndexOf(NeuIp) >= 0 then
                  b := False;
            if b then
              if MyIps <> Nil then
                for i := 0 to ChildCount - 1 do
                  if Child(i) is tChildForm then
                    begin
                      f := Child(i) as tChildForm;
                      if f.Ips <> Nil then
                        if f.Ips.Count > 0 then
                          if MyIps.IndexOf(f.Ips[0]) >= 0 then
                            begin
                              Telegramm.Kennung        := TelegrammMitspieler;
                              Telegramm.MitspielSteine := Steine;
                              Telegramm.MitspielStdIp  :=
                                GetStdIp(NeuIp, MyIps);
                              Telegramm.MitspielIp     :=
                                Telegramm.MitspielStdIp;
                              Telegramm.MitspielHandle := f.RemoteHandle;
                              StrPCopy(Telegramm.MitspielName,
                                       Copy(f.Caption, 1,
                                            sizeof(Telegramm.MitspielName)
                                            - 1));
                              SendTelegramm(Telegramm, NeuIp);
                            end;
                    end;
          end;
        Count := 0;
        for i := 0 to ChildCount - 1 do
          if Child(i) is tChildForm then
            if (Child(i) as tChildForm).ToPlace then
              Inc(Count);
        if Count > 1 Then
          BtnNext.enabled := true
        else
          BtnNext.enabled := false;
      end;
  end;

procedure TMainForm.DeleteHost(Rechner : LongInt);
  var i : Integer;
  begin
    if Hosts <> Nil then
      begin
        i := Hosts.IndexOf(Rechner);
        if i >= 0 then
          begin
            Hosts.Delete(i);
            for i := 0 to ChildCount - 1 do
              if Child(i) is tChatForm then
                (Child(i) as tChatForm).DeleteHost(Inet_NtoA(tInAddr(Rechner)));
          end;
      end;
  end;

procedure TMainForm.SendTelegramm(Telegramm   : tTelegramm;
                                  Zielrechner : LongInt);
  var     ZielName  : String;
          l         : Integer;
          SockAddr  : tSockAddr;
          UDPSocket : tSocket;
          ok        : Boolean;
  begin
    if NetworkState = NetworkReady then
      begin
        Screen.Cursor := crHourGlass;
        {$ifdef fpc}
          UDPSocket := fpSocket(AF_Inet, LongInt(sock_dgram), UDPProto);
        {$else}
          UDPSocket := Socket(AF_Inet, sock_dgram, UDPProto);
        {$endif} 
        if UDPSocket = Invalid_Socket then
          MsgBox('Open socket: ' + WSAErrorString(WsaGetLastError),
                 Caption, mb_IconHand)
        else
          begin
            ok := True;
            if ZielRechner = LongInt(InAddr_Broadcast) then
              begin
                Zielname := 'any PC';
                l        := 1;
                if SetSockOpt(UDPSocket, Sol_Socket, so_Broadcast,
                              @l, sizeof(l)) <> 0 then
                  begin
                    MsgBox('set socket to broadcast: '
                           + WSAErrorString(WsaGetLastError),
                           Caption, mb_IconHand);
                    ok := False;
                  end;
              end
            else
              ZielName := Inet_NtoA(tInAddr(Zielrechner));
            if ok then
              begin
                SockAddr.SIn_Family      := AF_Inet;
                SockAddr.SIn_Port        := UDPPort;
                SockAddr.SIn_Addr.s_Addr := Zielrechner;
                {$ifdef fpc}
                  if fpConnect(UDPSocket, @SockAddr, sizeof(SockAddr)) <> 0 then 
                {$else}
                  if Connect(UDPSocket, SockAddr, sizeof(SockAddr)) <> 0 then
                {$endif}
                  DeleteHost(Zielrechner)
                else
                  begin
                    {$ifdef fpc}
                      l := fpSend(UDPSocket, @Telegramm, sizeof(Telegramm), 0);
                    {$else}
                      l := Send(UDPSocket, Telegramm, sizeof(Telegramm), 0);
                    {$endif}
                    if l <> sizeof(Telegramm) then
                      begin
                        if l = Socket_Error then
                          MsgBox('send to ' + ZielName + ': '
                                 + WSAErrorString(WsaGetLastError),
                                 Caption, mb_IconHand)
                        else
                          MsgBox('send to ' + ZielName + ' incomplete',
                                 Caption, mb_IconHand)
                      end;
                    CloseSocket(UDPSocket);
                  end;
              end;
          end;
        Screen.Cursor := crDefault;
      end;
  end;

procedure TMainForm.ShowPanel(PanelVisible : Boolean);
  var     i          : Integer;
          s          : String;
          Nummer     : Word;
          HexVisible : Array[0 .. ZuSetzen - 1] of Boolean;
  begin
    if PanelVisible then
      for i := 0 to ChildCount - 1 do
        if Child(i) is tChatForm then
          begin
            if (Child(i) as tChatForm).Running then
              PanelVisible := False;
          end
        else
          if Child(i) is tChildForm then
            if (Child(i) as tChildForm).Running then
              PanelVisible := False;
    {$ifdef fpc}
      Constraints.MinHeight := 0;
      Constraints.MaxHeight := 0;
      if PanelVisible then
        Height       := FullHeight
      else
        ClientHeight := ToolBar.Height;
      Constraints.MinHeight := Height;
      Constraints.MaxHeight := Height;
    {$endif}
    if PanelVisible then
      begin
        NewSize;
        Panel.Color := GlobBackground;
        for i := ZuSetzen div 2 + 2 to GesamtSteine do
          begin
            Str(i, s);
            (FindComponent(HexName + s) as tHexagon).Init(Steine[i], hxHidden);
          end;
        for i := 0 to ZuSetzen - 1 do
          HexVisible[i] := False;
        OptimumDemo := Random(OptimumAnz) + 1;
        for i := 0 to ZuSetzen div 2 do
          begin
            Nummer := Random(ZuSetzen);
            while HexVisible[Nummer] do
              Nummer := (Nummer + 1) mod ZuSetzen;
            HexVisible[Nummer] := True;
            str(OptimumListe[OptimumDemo, Nummer].Hexagon, s);
            (Findcomponent('Hexagon' + s) as tHexagon).
              Init(OptimumListe[OptimumDemo, Nummer].Wert, hxVisible);
          end;
        Nummer := Random(ZuSetzen);
        while HexVisible[Nummer] do
          Nummer := (Nummer + 1) mod ZuSetzen;
        for i := 0 to ZuSetzen - 1 do
          if not HexVisible[i] then
            begin
              str(OptimumListe[OptimumDemo, i].Hexagon, s);
              (Findcomponent('Hexagon' + s) as tHexagon).
                Init(OptimumListe[OptimumDemo, Nummer].Wert, hxEmpty);
            end;
        Nummer := Random(ZuSetzen);
        while HexVisible[Nummer] do
          Nummer := (Nummer + 1) mod ZuSetzen;
        str(OptimumListe[OptimumDemo, Nummer].Hexagon, s);
        (Findcomponent('Hexagon' + s)as tHexagon).
          Style := hxHighlight;
        Calculate;
      end;
    Timer.Enabled     := Panelvisible;
    Panel.visible     := Panelvisible;
    BtnNeu.visible    := not Panelvisible;
    BtnNeuAtn.visible := Panelvisible;
  end;

procedure TMainForm.BtnNeuClick(Sender: TObject);
  var     Telegramm   : tTelegramm;
          Form        : tChildForm;
          Zielrechner : LongInt;
          ZielName    : String;
          i           : Integer;
  begin
    if PlayerForm.ShowModal = mrOk Then
      if Copy(PlayerForm.Spieler.Text, 1, 2) = '\\' then
        begin
          if NetworkState <> NetworkReady then
            EditNetwork;
          if NetworkState = NetworkReady then
            begin
              ZielName    := Copy(PlayerForm.Spieler.Text, 3,
                                  length(PlayerForm.Spieler.Text));
              Zielrechner := GetIpAddr(ZielName);
              if Zielrechner = longint(InAddr_None) then
                case SysLocale.PriLangID of
                  Lang_German:
                    MsgBox('Rechner "' + ZielName + '" nicht gefunden',
                           Caption, mb_IconHand);
                else
                    MsgBox('Could not find PC named "' + ZielName + '"',
                           Caption, mb_IconHand);
                end
              else
                if MyIps <> Nil then
                  begin
                    NotifyAddress(Zielrechner);
                    Telegramm.Kennung := TelegrammAnfrageMitAntwort;
                    for i := 0 to ChildCount - 1 do
                      if Child(i) is tChildForm then
                        begin
                          Telegramm.Kennung := TelegrammMitspieler;
                          (Child(i) as tChildForm).SendeSpiel(Zielrechner);
                        end;
                    if Telegramm.Kennung = TelegrammAnfrageMitAntwort then
                      begin
                        Telegramm.AnfrageIp := GetStdIp(Zielrechner, MyIps);
                        SendTelegramm(Telegramm, Zielrechner);
                      end;
                  end;
            end;
        end
      else
        begin
          Form := NeuerSpieler(0, 0, PlayerForm.Spieler.Text, 0);
          if Form <> Nil then
            if PlayerForm.Spieler.Text = 'PC' Then
              Form.PCSpiel;
        end;
  end;

procedure TMainForm.FormCreate(Sender: TObject);
  var     IniFile   : tIniFile;
          Player,
          s         : String;
          i         : Integer;
          l         : LongInt;
  begin
    Panel.align   := alClient;
    FullHeight    := Height;
    Children      := tList.Create;
    Blink         := False;
    NetworkState  := NetworkNotAvailable;
    Hosts         := tLongIntList.Create;
    MyIps         := tLongIntList.Create;
    NetworkThread := Nil;
    Start         := True;
    case SysLocale.PriLangID of
      Lang_German:
        Application.Title := 'Take it easy';
    else
      Application.Title           := 'Hextension';
      MenuSpiel.Caption           := '&Game';
      MenuNeu.Caption             := '&New player';
      MenuHigh.Caption            := '&High score';
      MenuFenster.Caption         := '&Window';
      {$ifndef fpc}
        MenuUeberlappend.Caption    := '&Cascade';
        MenuNebeneinander.Caption   := '&Tile';
        MenuSymboleAnordnen.Caption := '&Arrange icons';
      {$endif}
      MenuAmZug.Caption           := 'Next &Player due';
      MenuChat.Caption            := '&Messages';
      MenuEinstellung.Caption     := '&Settings';
      MenuFarben.Caption          := '&Colors';
      MenuNetzwerk.Caption        := '&Network';
      MenuShortcut.Caption        := '&Shortcuts';
      MenuInfo.Caption            := '&Info';
      MenuEignung.Caption         := 'S&uitability';
      MenuIdee.Caption            := '&Idea';
      MenuProgramm.Caption        := '&Program';
      MenuZiel.Caption            := '&Strategy';
      MenuOpt.Caption             := '&Optimal solutions';
      BtnNeu.Hint                 := 'New player';
      BtnNeuAtn.Hint              := 'New player';
      BtnFarben.Hint              := 'Change colors';
      BtnHighscore.Hint           := 'High score';
      BtnOpt.Hint                 := 'Optimal solutions';
      BtnNext.Hint                := 'Next Player due';
      BtnEignung.Hint             := 'About suitability';
      BtnIdee.Hint                := 'About idea';
      BtnProg.Hint                := 'About program';
      BtnZiel.Hint                := 'About strategy';
      Bewertung.Items[0]          := '&points';
      Bewertung.Items[1]          := '&quality';
    end;
    Caption := Application.Title;
    Randomize;
    NeueSteine;
    LoadFormFromIni(Self, Name);
    IniFile := tIniFile.Create(IniName);
    for i := 1 to MaxHighScore do
      begin
        str(i, s);
        Player := IniFile.ReadString( IniHighScore, IniPlayer + s, '');
        l      := IniFile.ReadInteger(IniHighScore, IniPoints + s, 0);
        InsertScore(Player, l);
      end;
    for i := 1 to 9 do
      begin
        str(i, s);
        GlobLinecolors[i] := IniFile.ReadInteger(IniColors, IniLine + s,
                                                 GlobLinecolors[i]);
      end;
    GlobBackground :=
      IniFile.ReadInteger(IniColors, IniBackground, GlobBackground);
    GlobShadow     :=
      IniFile.ReadInteger(IniColors, IniShadow,     GlobShadow);
    GlobLight      :=
      IniFile.ReadInteger(IniColors, IniLight,      GlobLight);
    IniFile.Free;
  end;

procedure TMainForm.ThreadReady;
  var     Telegramm : tTelegramm;
          i         : Integer;
  begin
    if BtnNeu.enabled then
      if MyIps <> Nil then
        begin
          Telegramm.Kennung := TelegrammAnfrageOhneAntwort;
          for i := 0 to MyIps.Count - 1 do
            begin
              Telegramm.AnfrageIp := MyIps[i];
              SendTelegramm(Telegramm, LongInt(InAddr_Broadcast));
            end;
        end;
  end;

procedure TMainForm.NeueSteine;
  var     Erledigt  : Set of 0 .. (GesamtSteine - 1);
          i, Nummer : Integer;
  begin
    Erledigt := [];
    for i := 1 to GesamtSteine do
      begin
        Nummer := Random(GesamtSteine);
        while Nummer in Erledigt do
          begin
            if Nummer = 26 then
              Nummer := 0
            else
              Inc(Nummer);
          end;
        Erledigt  := Erledigt + [Nummer];
        Steine[i] := Nummer;
      end;
  end;

procedure TMainForm.InsertScore(Player : String; Punkte: Word);
  var     i, j : Integer;
          b    : Boolean;
  begin
    if Copy(Player, 1, 2) = '\\' then
      Player := Copy(Player, 3, length(Player));
    i := Pos('\', Player);
    if i > 0 then
      Player := Copy(Player, i + 1, length(Player));
    if (0 < Punkte) and (Punkte <= OptimumPkte) Then
      begin
        b := True;
        i := MaxHighScore;
        while (i >= 1) and b do
          begin
            if Player = HighScore[i].Name then
              begin
                if Punkte > HighScore[i].Punkte then
                  begin
                    j := i;
                    while (j > 1) and b do
                      if Punkte > HighScore[j - 1].Punkte then
                        begin
                          HighScore[j].Punkte := HighScore[j - 1].Punkte;
                          HighScore[j].Name   := HighScore[j - 1].Name;
                          dec(j);
                        end
                      else
                        b := False;
                    HighScore[j].Punkte := Punkte;
                    HighScore[j].Name   := Player;
                  end;
                b := False;
              end
            else
              dec(i);
          end;
        if b then
          if Punkte <= HighScore[MaxHighScore].Punkte then
            b := False;
        if b then
          begin
            i := MaxHighScore;
            while (i > 1) and b do
              if Punkte > HighScore[i - 1].Punkte then
                begin
                  HighScore[i].Punkte := HighScore[i - 1].Punkte;
                  HighScore[i].Name   := HighScore[i - 1].Name;
                  dec(i);
                end
              else
                b := False;
            HighScore[i].Punkte := Punkte;
            HighScore[i].Name   := Player;
          end;
      end;
  end;

procedure TMainForm.NotifyAddress(Ip: LongInt);
  begin
    if Hosts <> Nil then
      if MyIps <> Nil then
        if MyIps.IndexOf(Ip) < 0 then
          begin
            if Hosts.IndexOf(Ip) < 0 then
              Hosts.Add(Ip);
            StartChat;
          end;
  end;

procedure TMainForm.Anfrage(AnfrageIp : LongInt; Antwort : Boolean);
  var     Telegramm : tTelegramm;
          i         : Integer;
          b         : Boolean;
          f         : tChildForm;
  begin
    Telegramm.Kennung := TelegrammNotifyAddress;
    if MyIps <> Nil then
      if MyIps.IndexOf(AnfrageIp) < 0 then
        begin
          NotifyAddress(AnfrageIp);
          if not BtnNeu.enabled then
            begin
              if Antwort then
                begin
                  Telegramm.Kennung    := TelegrammBereitsBegonnen;
                  Telegramm.AblehnerIp := GetStdIp(AnfrageIp, MyIps);
                  SendTelegramm(Telegramm, AnfrageIp);
                end;
            end
          else
            begin
              for i := 0 to ChildCount - 1 do
                if Child(i) is tChildForm then
                  begin
                    f := Child(i) as tChildForm;
                    b := Antwort;
                    if not b then
                      if f.Ips <> Nil then
                        if f.Ips.Count > 0 then
                          if (MyIps.IndexOf(f.Ips[0]) >= 0) then
                            b := True;
                    if b then
                      begin
                        Telegramm.Kennung := TelegrammMitspieler;
                        f.SendeSpiel(AnfrageIp);
                      end;
                  end;
              If Antwort and (Telegramm.Kennung = TelegrammNotifyAddress) then
                begin
                  Telegramm.Kennung    := TelegrammNochNichtBegonnen;
                  Telegramm.AblehnerIp := GetStdIp(AnfrageIP, MyIps);
                  SendTelegramm(Telegramm, AnfrageIp);
                end;
              If Telegramm.Kennung = TelegrammNotifyAddress then
                begin
                  Telegramm.AnfrageIp := GetStdIp(AnfrageIP, MyIps);
                  SendTelegramm(Telegramm, AnfrageIp);
                end;
            end;
        end;
  end;

procedure TMainForm.EnableNeu(NeuEnabled : Boolean);
  begin
    MenuNeu.enabled   := NeuEnabled;
    BtnNeu.enabled    := NeuEnabled;
    BtnNeuAtn.enabled := NeuEnabled;
  end;

procedure TMainForm.NextWindow;
  var     i,
          Count,
          Placing   : Integer;
          Telegramm : tTelegramm;
          b         : Boolean;
          f, g      : tChildForm;
  begin
    Placing := -1;
    Count   := 0;
      for i := 0 to ChildCount - 1 do
        if Child(i) is tChildForm then
          begin
            f := Child(i) as tChildForm;
            if f.Running then
              begin
                Inc(Count);
                if f.ToPlace then
                  begin
                    if Placing < 0 then
                      Placing := i
                    else
                      {$ifndef fpc}
                        if f <> ActiveMDIchild then
                      {$endif}
                        if MyIps <> Nil then
                          begin
                            b := False;
                            if f.Ips <> Nil then
                              if f.Ips.Count > 0 then
                                if MyIps.IndexOf(f.Ips[0]) >= 0 then
                                  b := True;
                            if b then
                              Placing := i
                            else
                              begin
                                g := Child(Placing) as tChildForm;
                                if g.Ips <> Nil then
                                  if g.Ips.Count > 0 then
                                    if MyIps.IndexOf(g.Ips[0]) < 0 then
                                      b := True;
                                if b then
                                  Placing := i;
                              end;
                          end;
                  end;
              end;
          end;
      if Placing < 0 then
        begin
          for i := 0 to ChildCount - 1 do
            if Child(i) is tChildForm then
              (Child(i) as tChildForm).NextStein;
          EnableNeu(False);
          for i := 0 to ChildCount - 1 do
            if Child(i) is tChildForm then
              begin
                f := Child(i) as tChildForm;
                if Placing < 0 then
                  Placing := i
                else
                  if MyIps <> Nil then
                    begin
                      b := False;
                      if f.Ips <> Nil then
                        if f.Ips.Count > 0 then
                          if MyIps.IndexOf(f.Ips[0]) >= 0 then
                            b := True;
                      if b then
                        Placing := i
                      else
                        begin
                          g := Child(Placing) as tChildForm;
                          if g.Ips <> Nil then
                            if g.Ips.Count > 0 then
                              if MyIps.IndexOf(g.Ips[0]) < 0 then
                                b := True;
                          if b then
                            Placing := i;
                        end;
                    end;
              end;
        end;
      if Placing >= 0 then
        begin
          Child(Placing).WindowState := wsNormal;
          Child(Placing).BringToFront;
        end;
    if Count > 1 then
      BtnNext.enabled := true
    else
      BtnNext.enabled := False;
    Save;
    if Count = 0 Then
      begin
        EnableNeu(True);
        ShowPanel(True);
        if MyIps <> Nil then
          for i := MyIps.Count - 1 downto 0 do
            begin
              Telegramm.Kennung   := TelegrammAnfrageOhneAntwort;
              Telegramm.AnfrageIp := MyIps[i];
              SendTelegramm(Telegramm, LongInt(InAddr_Broadcast));
            end;
        NewSize;
        NeueSteine;
      end;
  end;

procedure TMainForm.ShowHighScore(Sender: TObject);
  begin
    ScoreForm.Fill(HighScore);
    ScoreForm.ShowModal;
  end;

procedure TMainForm.NewColors;
  var     i : Integer;
  begin
    Panel.Color := GlobBackground;
    for i := 0 to Panel.ControlCount - 1 do
      if Panel.Controls[i] is tPkteLabel then
        (Panel.Controls[i] as tPkteLabel).NewColors
      else
        if Panel.Controls[i] is tHexagon then
          (Panel.Controls[i] as tHexagon).NewColors(
            GlobLineColors, GlobBackground, GlobLight, GlobShadow);
    for i := 0 to ChildCount - 1 do
      if Child(i) is tChildForm then
        (Child(i) as tChildForm).NewColors;
  end;

procedure TMainForm.FarbenEinstellen(Sender: TObject);
  begin
    if ColorsForm.Showmodal = mrOk then
      NewColors;
  end;

procedure TMainForm.ShowAutor(Sender: TObject);
  begin
    AuthorForm.ShowModal;
  end;

procedure TMainForm.ShowIdee(Sender: TObject);
  begin
    IdeaForm.ShowModal;
  end;

procedure TMainForm.Optimum(Sender: TObject);
  begin
    OptimumForm.ShowModal;
  end;

procedure TMainForm.Save;
  var     i       : Integer;
          IniFile : tIniFile;
          s       : String;
          f       : tChildForm;
  begin
    for i := 0 to ChildCount - 1 do
      if Child(i) is tChildForm then
        begin
          f := Child(i) as tChildForm;
          if f.Hexagon = GesamtSteine Then
            begin
              f.Bewertung.ItemIndex := 0;
              f.Calculate;
              InsertScore(f.Caption, f.Punkte);
            end;
        end;
    IniFile := tIniFile.Create(IniName);
    for i := 1 to MaxHighScore do
      begin
        str(i, s);
        IniFile.WriteString( IniHighScore, IniPlayer + s, HighScore[i].Name);
        IniFile.WriteInteger(IniHighScore, IniPoints + s, HighScore[i].Punkte);
      end;
    IniFile.Free;
    SaveFormToIni(Self, Name);
  end;

procedure TMainForm.ShowStrategie(Sender: TObject);
  begin
    StrategyForm.ShowModal;
  end;

procedure TMainForm.Calculate;
  var     Punkte  : Word;
          s       : String;
          bewMode : tBewertung;
  begin
    if Bewertung.ItemIndex = 0 then
      bewMode := bewDemoPunkte
    else
      bewMode := BewDemoEnde;
    Punkte := 0;
    Inc(Punkte, Hoch1.Calculate(Hexagon113,
                                Hexagon124,
                                Hexagon135,
                                nil,
                                nil,
                                rHoch, bewMode));
    Inc(Punkte, Hoch2.Calculate(Hexagon212,
                                Hexagon223,
                                Hexagon234,
                                Hexagon245,
                                nil,
                                rHoch, bewMode));
    Inc(Punkte, Hoch3.Calculate(Hexagon311,
                                Hexagon322,
                                Hexagon333,
                                Hexagon344,
                                Hexagon355,
                                rHoch, bewMode));
    Inc(Punkte, Hoch4.Calculate(Hexagon421,
                                Hexagon432,
                                Hexagon443,
                                Hexagon454,
                                nil,
                                rHoch, bewMode));
    Inc(Punkte, Hoch5.Calculate(Hexagon531,
                                Hexagon542,
                                Hexagon553,
                                nil,
                                nil,
                                rHoch, bewMode));
    Inc(Punkte, Auf1.Calculate (Hexagon113,
                                Hexagon212,
                                Hexagon311,
                                nil,
                                nil,
                                rAuf,  bewMode));
    Inc(Punkte, Auf2.Calculate (Hexagon124,
                                Hexagon223,
                                Hexagon322,
                                Hexagon421,
                                nil,
                                rAuf,  bewMode));
    Inc(Punkte, Auf3.Calculate (Hexagon135,
                                Hexagon234,
                                Hexagon333,
                                Hexagon432,
                                Hexagon531,
                                rAuf,  bewMode));
    Inc(Punkte, Auf4.Calculate (Hexagon245,
                                Hexagon344,
                                Hexagon443,
                                Hexagon542,
                                nil,
                                rAuf,  bewMode));
    Inc(Punkte, Auf5.Calculate (Hexagon355,
                                Hexagon454,
                                Hexagon553,
                                nil,
                                nil,
                                rAuf,  bewMode));
    Inc(Punkte, Ab1.Calculate  (Hexagon311,
                                Hexagon421,
                                Hexagon531,
                                nil,
                                nil,
                                rAb,   bewMode));
    Inc(Punkte, Ab2.Calculate  (Hexagon212,
                                Hexagon322,
                                Hexagon432,
                                Hexagon542,
                                nil,
                                rAb,   bewMode));
    Inc(Punkte, Ab3.Calculate  (Hexagon113,
                                Hexagon223,
                                Hexagon333,
                                Hexagon443,
                                Hexagon553,
                                rAb,   bewMode));
    Inc(Punkte, Ab4.Calculate  (Hexagon124,
                                Hexagon234,
                                Hexagon344,
                                Hexagon454,
                                nil,
                                rAb,   bewMode));
    Inc(Punkte, Ab5.Calculate  (Hexagon135,
                                Hexagon245,
                                Hexagon355,
                                nil,
                                nil,
                                rAb,   bewMode));
    str(Punkte, s);
    Bewertung.Caption := s;
  end;

procedure TMainForm.TimerTimer(Sender: TObject);
  var     i, j  : Word;
          s     : String;
          Hex,
          Neu   : tHexagon;
  begin
    Blink := Not Blink;
    if Blink Then
      begin
        Neu := Nil;
        i   := Random(ZuSetzen);
        for j := 1 to ZuSetzen do
          begin
            str(OptimumListe[OptimumDemo,(i + j) mod ZuSetzen].Hexagon, s);
            Hex := Findcomponent('Hexagon' + s) as tHexagon;
            if Hex.Style = hxHighlight then
              Hex.Style := hxEmpty
            else
              if Hex.Style = hxEmpty Then
                Neu := Hex;
          end;
        if Neu <> Nil then
          Neu.Style := hxHighlight;
        Calculate;
      end
    else
      begin
        if BtnNeu.Visible then
          begin
            BtnNeu.Visible    := False;
            BtnNeuAtn.Visible := True;
          end
        else
          begin
            BtnNeu.Visible    := True;
            BtnNeuAtn.Visible := False;
          end;
      end;
  end;

procedure TMainForm.NewSize;
  var     i, h, w : Integer;
          c       : tControl;
  begin
    h := Panel.Height;
    w := (h * 540) div 280;
    if w > Panel.Width then
      begin
        w := Panel.Width;
        h := (w * 280) div 540;
      end;
    for i := 0 to Panel.ControlCount - 1 do
      begin
        c := Panel.Controls[i];
        if c is tHexagon then
          (c as tHexagon).HexResize(h, w);
      end;
    Hoch1.Left := (49 * w) div 100;
    Hoch1.Top  := (24 * h) div 100 - Hoch1.Height;
    Hoch2.Left := (57 * w) div 100;
    Hoch2.Top  := (14 * h) div 100 - Hoch2.Height;
    Hoch3.Left := (65 * w) div 100;
    Hoch3.Top  := ( 5 * h) div 100 - Hoch3.Height;
    Hoch4.Left := (73 * w) div 100;
    Hoch4.Top  := (14 * h) div 100 - Hoch4.Height;
    Hoch5.Left := (81 * w) div 100;
    Hoch5.Top  := (24 * h) div 100 - Hoch5.Height;
    Ab1.Left   := (85 * w) div 100;
    Ab1.Top    := (36 * h) div 100;
    Ab2.Left   := (85 * w) div 100;
    Ab2.Top    := (55 * h) div 100;
    Ab3.Left   := (85 * w) div 100;
    Ab3.Top    := (74 * h) div 100;
    Ab4.Left   := (77 * w) div 100;
    Ab4.Top    := (83 * h) div 100;
    Ab5.Left   := (69 * w) div 100;
    Ab5.Top    := (93 * h) div 100;
    Auf1.Left  := (47 * w) div 100 - Auf1.Width;
    Auf1.Top   := (36 * h) div 100;
    Auf2.Left  := (47 * w) div 100 - Auf2.Width;
    Auf2.Top   := (55 * h) div 100;
    Auf3.Left  := (47 * w) div 100 - Auf3.Width;
    Auf3.Top   := (74 * h) div 100;
    Auf4.Left  := (55 * w) div 100 - Auf4.Width;
    Auf4.Top   := (83 * h) div 100;
    Auf5.Left  := (63 * w) div 100 - Auf5.Width;
    Auf5.Top   := (93 * h) div 100;
    Bewertung.Left := w - Bewertung.Width - (3 * Rand) div 2;
  end;

procedure TMainForm.MenuUeberlappendClick(Sender: TObject);
  {$ifndef fpc}
    var   i, h, w : Integer;
          f       : tChildForm;
  {$endif}
  begin
    {$ifndef fpc}
      h := 0;
      w := 0;
      for i := 0 to ChildCount - 1 do
        if (Child(i) is tChildForm) then
          begin
            f := Child(i) as tChildForm;
            if f.WindowState = wsNormal then
              begin
                h := f.Height;
                w := f.Width;
              end;
          end;
      Cascade;
      for i := 0 to ChildCount - 1 do
        if (Child(i) is tChildForm) then
          begin
            f := Child(i) as tChildForm;
            if f.WindowState = wsNormal then
              begin
                f.Height := h;
                f.Width  := w;
              end;
          end;
    {$endif}
  end;

procedure TMainForm.MenuNebeneinanderClick(Sender: TObject);
  begin
    {$ifndef fpc}
      Tile;
    {$endif}
  end;

procedure TMainForm.MenuSymboleAnordnenClick(Sender: TObject);
  begin
    {$ifndef fpc}
      ArrangeIcons;
    {$endif}
  end;

procedure TMainForm.BtnNextClick(Sender: TObject);
  begin
    NextWindow;
  end;

procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  var     i : Integer;
  begin
    if CloseAction = caFree then;
    for i := ChildCount - 1 downto 0 do
      if Child(i) is tChildForm then
        (Child(i) as tChildForm).Schliessen
      else
        if Child(i) is tChatForm then
          (Child(i) as tChatForm).Schliessen;
    if NetworkState = NetworkNotAvailable then
      NetworkState := NetworkTerminated
    else
      NetworkState := NetworkTerminating;
    if NetworkThread <> Nil then
      NetworkThread.WaitFor;
    Save;
  end;

procedure TMainForm.FormResize(Sender: TObject);
  begin
    NewSize;
  end;

procedure TMainForm.ShowEignung(Sender: TObject);
  begin
    case SysLocale.PriLangID of
      Lang_German:
        MsgBox(CP1252ToSystem(
          'Take it easy ist fr Spieler ab 10 Jahren geeignet.'),
          Caption, mb_ok);
    else
      MsgBox('Hextension is suitable for players of at least 10 years age.',
             Caption, mb_ok);
    end;
  end;

procedure TMainForm.BewertungClick(Sender: TObject);
  begin
    Calculate;
  end;

procedure TMainForm.MenuNetzwerkClick(Sender: TObject);
  begin
    EditNetwork;
  end;

procedure TMainForm.EditNetwork;
  var     s : String;
          i : Integer;
  begin
    s := InitNetwork;
    if s > '' then
      MsgBox(s, Caption, mb_IconHand)
    else
      if MyIps <> Nil then
        begin
          if UDPPort = 0 then
            s := ''
          else
            str(ntohs(UDPPort), s);
          PortForm.Port.Text := s;
          case SysLocale.PriLangID of
            Lang_German:
              if MyIps.Count > 1 then
                PortForm.MyIpPrompt.Caption := 'Meine IPs'
              else
                PortForm.MyIpPrompt.Caption := 'Meine IP';
          else
            if MyIps.Count > 1 then
              PortForm.MyIpPrompt.Caption := 'My IPs'
            else
              PortForm.MyIpPrompt.Caption := 'My IP';
          end;
          PortForm.MyIpList.Caption := '';
          for i := 0 to MyIps.Count - 1 do
            PortForm.MyIpList.Caption :=
              PortForm.MyIpList.Caption + inet_NtoA(tInAddr(MyIps[i])) + A_LF;
          PortForm.MyIpList.Caption :=
            Copy(PortForm.MyIpList.Caption,
                 1, length(PortForm.MyIpList.Caption) - 1);
          PortForm.ClientHeight :=
            PortForm.MyIpList.Top + PortForm.MyIpList.Height + 5;
          if PortForm.ShowModal = mrOk then
            begin
              s := InitNetwork;
              if s > '' then
                MsgBox(s, Caption, mb_IconHand);
            end;
        end;
  end;

function TMainForm.InitNetwork : String;
  var    Protocol  : pProtoEnt;
         {$ifndef fpc}
           WsaData : tWsaData;
           i       : Integer;
         {$endif}
         ServEnt   : pServEnt;
  begin
    InitNetwork   := '';
    if MyIps <> Nil then
      begin
        Screen.Cursor := crHourGlass;
        MyIps.Clear;
        if NetworkState = NetworkNotAvailable then
          {$ifdef fpc}
            NetworkState := NetworkStarted;
          {$else} 
            begin
              i := WSAStartUp(MakeWord(1, 0), WsaData);
              if i <> 0 then
                InitNetwork  := 'WinSock start up: ' + WsaErrorString(i)
              else
                NetworkState := NetworkStarted;
            end;
          {$endif}
        if (NetworkState <> NetworkNotAvailable) then
          begin
            if GetHostName(MyHostName, sizeof(MyHostName)) <> 0 then
              InitNetwork := 'Get my network name: '
                             + WSAErrorString(WsaGetLastError)
            else
              begin
                if not GetMyIps then
                  InitNetwork := 'Get my IPs: '
                                 + WSAErrorString(WsaGetLastError)
                else
                  begin
                    Protocol := GetProtoByName('udp');
                    if Protocol = Nil then
                      InitNetwork := 'Get protocol UDP by name: '
                                     + WSAErrorString(WsaGetLastError)
                    else
                      begin
                        UDPProto := Protocol^.p_proto;
                        ServEnt  := GetServByName(UDPService, 'udp');
                        if ServEnt = Nil then
                          UDPPort := 0
                        else
                          begin
                            UDPPort := ServEnt^.s_Port;
                            if NetworkState <> NetworkBlocked then
                              NetworkState := NetworkReady;
                          end;
                      end;
                  end;
              end;
          end;
        Screen.Cursor := crDefault;
      end;
  end;

procedure TMainForm.DeletePlayer(DeleteIp : LongInt; DeleteHandle : tHandle);
  var i : Integer;
      f : tChildForm;
  begin
    if MyIps <> Nil then
      if MyIps.IndexOf(DeleteIp) < 0 then
        for i := ChildCount - 1 downto 0 do
          if Child(i) is tChildForm then
            begin
              f := Child(i) as tChildForm;
              if f.Ips.IndexOf(DeleteIp) >= 0 then
                if f.RemoteHandle = DeleteHandle then
                  f.Schliessen;
            end;
  end;

procedure TMainForm.SteinGesetzt(GesetztIp     : LongInt;
                                 GesetztHandle : tHandle;
                                 GesetztNr     : ShortInt;
                                 GesetztZiel   : Word;
                                 Endgueltig    : Boolean);
  var i    : Integer;
      f, g : tChildForm;
  begin
    f := Nil;
    for i := 0 to ChildCount - 1 do
      if Child(i) is tChildForm then
        begin
          g := Child(i) as tChildForm;
          if g.Ips.IndexOf(GesetztIp) >= 0 then
            if g.RemoteHandle = GesetztHandle then
              f := g;
        end;
    if f <> Nil then
      f.SteinGesetzt(GesetztNr, GesetztZiel, Endgueltig);
  end;

procedure TMainForm.MenuShortcutClick(Sender: TObject);
  begin
    {$ifndef fpc}
      LinkForm.ShowModal;
    {$endif}
  end;

procedure TMainForm.ThreadBlocked;
  begin
    NetworkState := NetworkBlocked;
    StopChat;
  end;

procedure TMainForm.CheckHosts;
  var     i, j, k    : Integer;
          MustDelete : Boolean;
          f          : tChildForm;
  begin
    if Hosts <> Nil then
      if MyIps <> Nil then
        for i := Hosts.Count - 1 downto 0 do
          begin
            MustDelete := True;
            for j := 0 to ChildCount - 1 do
              if Child(j) is tChildForm then
                begin
                  f := Child(j) as tChildForm;
                  for k := 0 to f.IPs.Count - 1 do
                    if Hosts.IndexOf(f.Ips[k]) >= 0 then
                      MustDelete := False;
                end;
            if MustDelete then
              Hosts.Delete(i);
          end;
  end;

Procedure TMainForm.Chat(ChatIp : LongInt; ChatStdIp : LongInt; ChatText : String);
  var     ChatForm : tChatForm;
  begin
    ChatForm := StartChat;
    if ChatForm <> nil then
      ChatForm.Chat(ChatIp, ChatStdIp, ChatText);
  end;

procedure TMainForm.StopChat;
  var i : Integer;
  begin
    for i := ChildCount - 1 downto 0 do
      if Child(i) is tChatForm then
        (Child(i) as tChatForm).Schliessen;
    MenuChat.enabled := False;
  end;

function TMainForm.StartChat : tChatForm;
  var    i : Integer;
         f : tChatForm;
  begin
    StartChat        := Nil;
    f                := Nil;
    MenuChat.enabled := True;
    ShowPanel(False);
    for i := 0 to ChildCount - 1 do
      if Child(i) is tChatForm then
        f := Child(i) as tChatForm;
    if f = Nil then
      begin
        f := tChatForm.Create(Self);
        if f <> Nil then
          begin
            f.Running  := False;
            f.Messages := tList.Create;
            if f.Messages = Nil then
              begin
                f.Release;
                f := Nil;
              end;
            {$ifdef fpc}
              if f <> Nil then
                Children.add(f);
            {$endif}
          end;
      end;
    if f <> Nil then
      begin
        for i := 0 to Hosts.Count - 1 do
          f.AddHost(Inet_NtoA(tInAddr(Hosts[i])));
        StartChat := f;
      end;
  end;

procedure TMainForm.MenuChatClick(Sender: TObject);
  begin
    StartChat;
  end;

procedure TMainForm.FormShow(Sender: TObject);
  begin
    if Start then
      begin
        Start := False;
        NewColors;
        InitNetwork;
        ShowPanel(True);
        NetworkThread := tNetworkThread.Create(False);
      end;
  end;

procedure TMainForm.FormDestroy(Sender: TObject);
  begin
    MyIps.Free;
    Hosts.Free;
    while ChildCount > 0 do
      Children.Delete(0);
    Children.Free;
  end;

procedure TMainForm.ChildSchliessen(Form : tForm);
  {$ifdef fpc}
    var   i : Integer;
  {$endif}
  begin
    {$ifdef fpc}
      i := Children.IndexOf(Form);
      if i >= 0 then
        Children.Delete(i);
    {$endif}
    NextWindow;
  end;

end.
