unit optimum;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Buttons,
  Zusatz,
  Hexagon,
  Spin;

type
  TOptimumForm = class(TForm)
    Hexagon311 : tHexagon;
    Hexagon113 : tHexagon;
    Hexagon212 : tHexagon;
    Hexagon322 : tHexagon;
    Hexagon421 : tHexagon;
    Hexagon531 : tHexagon;
    Hexagon542 : tHexagon;
    Hexagon432 : tHexagon;
    Hexagon333 : tHexagon;
    Hexagon223 : tHexagon;
    Hexagon124 : tHexagon;
    Hexagon234 : tHexagon;
    Hexagon344 : tHexagon;
    Hexagon443 : tHexagon;
    Hexagon553 : tHexagon;
    Hexagon454 : tHexagon;
    Hexagon355 : tHexagon;
    Hexagon245 : tHexagon;
    Hexagon135 : tHexagon;
    BtnOk      : TButton;
    Punkte     : TLabel;
    SpinEdit   : TSpinEdit;
    procedure    FormCreate(Sender: TObject);
    procedure    ToFront(Sender: TObject);
    procedure    FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure    SpinEditChange(Sender: TObject);
    procedure    FormShow(Sender: TObject);
  private
    procedure    Fill;
    procedure    NewColors;
  end;

var
  OptimumForm : TOptimumForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

procedure tOptimumForm.NewColors;
  var i : Integer;
  begin
    Color := GlobBackground;
    for i := 0 to ControlCount - 1 do
      if Controls[i] is tHexagon then
        (Controls[i] as tHexagon).NewColors(
          GlobLineColors, GlobBackground, GlobLight, GlobShadow);
  end;

procedure tOptimumForm.Fill;
  var i : Word;
      s : String;
  begin
    for i := 0 to ZuSetzen - 1 do
      begin
        str(OptimumListe[SpinEdit.Value, i].Hexagon, s);
        (Findcomponent('Hexagon' + s) as tHexagon).Init(
          OptimumListe[SpinEdit.Value, i].Wert, hxVisible);
      end;
  end;

procedure TOptimumForm.FormCreate(Sender: TObject);
  var s : String;
  begin
    Color := GlobBackground;
    str(OptimumPkte, s);
    case SysLocale.PriLangID of
      Lang_German:
        Punkte.Caption := s + ' Punkte';
    else
      Caption        := 'Hextension optimum';
      Punkte.Caption := s + ' points';
    end;
    LoadFormFromIni(Self, Name);
    SpinEdit.MaxValue := OptimumAnz;
  end;

procedure TOptimumForm.ToFront(Sender: TObject);
  begin
    BringToFront;
  end;

procedure TOptimumForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self, Name);
  end;

procedure TOptimumForm.SpinEditChange(Sender: TObject);
  begin
    Fill;
  end;

procedure TOptimumForm.FormShow(Sender: TObject);
  begin
    NewColors;
  end;

end.
