unit score;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  Hexagon,
  Zusatz;

const
  MaxHighScore   = 5;

type
  tHighScore     = Array[1 .. MaxHighScore] of
                     Record
                       Name   : String;
                       Punkte : Word;
                     end;

  TScoreForm     = class(TForm)
    PlayerName   : TLabel;
    Punkte       : TLabel;
    Name1        : TEdit;
    Name3        : TEdit;
    Name4        : TEdit;
    Name5        : TEdit;
    Punkte1      : TEdit;
    Punkte2      : TEdit;
    Punkte3      : TEdit;
    Punkte4      : TEdit;
    Punkte5      : TEdit;
    Name2        : TEdit;
    Button       : TButton;
    procedure      FormCreate(Sender: TObject);
    procedure      FormDeactivate(Sender: TObject);
    procedure      FormClose(Sender: TObject; var CloseAction: TCloseAction);
  public
    procedure      Fill(HighScore : tHighScore);
  end;

var
  ScoreForm  : TScoreForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

procedure TScoreForm.fill(HighScore : tHighScore);
  var     s, t : String;
          i    : Integer;
          Edit : tEdit;
  begin
    for i := 1 to MaxHighscore do
      begin
        str(i, t);
        Edit := FindComponent('Name' + t) as tEdit;
        if Edit <> Nil then
          Edit.Text := HighScore[i].Name;
      end;
    for i := 1 to MaxHighscore do
      begin
        str(HighScore[i].Punkte, s);
        str(i, t);
        Edit := FindComponent('Punkte' + t) as tEdit;
        if Edit <> Nil then
          Edit.Text := s;
      end;
  end;

procedure TScoreForm.FormCreate(Sender: TObject);
  begin
    case SysLocale.PriLangID of
      Lang_German:
    else
      Caption            := 'Hextension high score';
      PlayerName.Caption := 'name';
      Punkte.Caption     := 'points';
    end;
    LoadFormFromIni(Self, Name);
  end;

procedure TScoreForm.FormDeactivate(Sender: TObject);
  begin
    BringToFront;
  end;

procedure TScoreForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self, Name);
  end;

end.
