unit ziel;

{$ifdef fpc}
  {$mode objfpc}{$H+}
{$endif}

interface

uses
  {$ifdef Unix}
    WolfUtil,
  {$else}
    Windows,
  {$endif}
  {$ifdef fpc}
    LResources,
  {$else}
    Messages,
  {$endif}
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Buttons,
  Zusatz,
  Hexagon;

type
  TStrategyForm  = class(TForm)
    Button       : TButton;
    Label1       : TLabel;
    Label2       : TLabel;
    Label3       : TLabel;
    Hexagon1     : tHexagon;
    Hexagon2     : tHexagon;
    Hexagon3     : tHexagon;
    Hexagon4     : tHexagon;
    Hexagon5     : tHexagon;
    Hexagon6     : tHexagon;
    procedure      FormCreate(Sender: TObject);
    procedure      ToFront(Sender: TObject);
    procedure      FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure      FormShow(Sender: TObject);
  private
    procedure      NewColors;
  end;

var
  StrategyForm: TStrategyForm;

implementation

{$ifdef fpc}
  {$R *.lfm}
{$else}
  {$R *.dfm}
{$endif}

procedure TStrategyForm.NewColors;
  var i : Integer;
  begin
    Color := GlobBackground;
    for i := 0 to ControlCount - 1 do
      if Controls[i] is tHexagon then
        (Controls[i] as tHexagon).NewColors(
          GlobLineColors, GlobBackground, GlobLight, GlobShadow);
  end;

procedure TStrategyForm.FormCreate(Sender: TObject);
  begin
    Color := GlobBackground;
    case SysLocale.PriLangID of
      Lang_German:
    else
      Caption        := 'Hextension strategy';
      Label1.Caption := 'Combine as many as possible lines ' +
                        'of all three directions ' +
                        'in througout the same value.';
      Label2.Caption := '3 chips of 6 = 18 points.';
      Label3.Caption := 'No points, because 4 is misplaced, ' +
                        'otherwise it had been 4 * 8.';
    end;
    LoadFormFromIni(Self, Name);
  end;

procedure TStrategyForm.ToFront(Sender: TObject);
  begin
    BringToFront;
  end;

procedure TStrategyForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    if CloseAction = caFree then;
    SaveFormToIni(Self, Name);
  end;

procedure TStrategyForm.FormShow(Sender: TObject);
  begin
    NewColors;
  end;

end.
